
// example presented in paragraph 7.4 of the manual
// https://maniFEM.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// mesh the flat torus RR2/ZZ2

#include "maniFEM.h"

using namespace maniFEM;


int main ( )

{	// begin with the usual two-dimensional space
	Manifold RR2 ( tag::Euclid, tag::of_dim, 2 );
	Function xy = RR2 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xy[0], y = xy[1];

	// define two actions on RR2 (translations)
	Manifold::Action g_horiz ( tag::transforms, xy, tag::into, (x+1.) && y ),
	                 g_vert  ( tag::transforms, xy, tag::into, x && (y+1.) );

	// and divide RR2 by the group of translations generated by { g_horiz, g_vert }
	Manifold torus_manif = RR2 .quotient ( g_horiz, g_vert );

	// one vertex is enough to start the process
	Cell A ( tag::vertex );  x(A) = 0.02;  y(A) = 0.02;

	// with this vertex, we build two segments
	Mesh seg_horiz = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g_horiz );
	Mesh seg_vert = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g_vert );

	// two segments are enough to define a rectangle
	Mesh torus = Mesh::Build ( tag::grid ) .shape ( tag::rectangle )
		.faces ( seg_horiz, seg_vert, seg_horiz .reverse(), seg_vert .reverse() ) .winding();
	// method 'winding' provides no specific information,
	// it just warns maniFEM that we are on a quotient manifold
	// and that it must take winding segments into account
	// specific information about winding numbers is included in the two segments

	// we could export 'torus' in msh format, taking advantage of the $Periodic section
	// (this is object of current work)
	// we can directly draw an unfolded mesh
	torus .export_to_file ( tag::eps, "torus.eps", tag::unfold,
	                        tag::over_region, -0.5 < x < 1.5, -0.2 < y < 1.2 );

	std::cout << "produced file torus.eps - please edit before viewing" << std::endl;

}  // end of main
